/************************************************************************/
/*                                                                      */
/*      MatchI86 -- Match engine (Intel 80x86 assembly)                 */
/*                                                                      */
/*      This module provides functions for regular expression searches  */
/*      that have been optimised in machine code.                       */
/*                                                                      */
/*      Copyright (C) Grouse Software 1995-7.  All rights reserved.     */
/*      Written for Grouse by behoffski (Brenton Hoff).                 */
/*                                                                      */
/*      Free software: no warranty; use anywhere is ok; spread the      */
/*      sources; note any mods; share variations and derivatives        */
/*      (including sending to behoffski@grouse.com.au).                 */
/*                                                                      */
/************************************************************************/

#ifndef REMATCH_H
#define REMATCH_H

#include <compdef.h>
#include "matcheng.h"

#ifdef __cplusplus
extern "C" {
#endif /*__cplusplus*/

/************************************************************************/
/*                                                                      */
/*      Match -- Determine whether RE matches string                    */
/*                                                                      */
/************************************************************************/
BOOL PAGE_ALIGNED
MatchI86_Match(MATCHENG_SPEC *pTable,
               CHAR *pTextStart,
               MATCHENG_DETAILS *pDetails);

#ifdef __cplusplus
}
#endif /*__cplusplus*/

#endif /*REMATCH_H*/

