/************************************************************************/
/*                                                                      */
/*      memlchr -- Fast, left-scanning memory search                    */
/*                                                                      */
/*      ANSI C provides memchr, which scans memory using ascending      */
/*      addresses (to the right), starting from the specified           */
/*      address.  However, there's no equivalent descending-address     */
/*      (to the left) function -- hence this module.                    */
/*                                                                      */
/*      Copyright (C) 1995-7 Grouse Software.  All rights reserved.     */
/*      Written for Grouse by behoffski (Brenton Hoff).                 */
/*                                                                      */
/*      Free software: no warranty; use anywhere is ok; spread the      */
/*      sources; note any mods; share variations and derivatives        */
/*      (including sending to behoffski@grouse.com.au).                 */
/*                                                                      */
/************************************************************************/

#ifndef MEMLCHR_H
#define MEMLCHR_H

#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif /*__cplusplus*/

void * memlchr(const void *buf, int c, size_t num);

#ifdef __cplusplus
}
#endif /*__cplusplus*/

#endif /*MEMLCHR_H*/
