%Fail = (
        "n", "",                   #Normal non-match
        "t", "trailing backslash", #Trailing backslash (as if you didn't know)
        "u", "Unmatched [",        #RE okay but no match
);

$Started = 1;
$Total = 0;

sub DoTest {
        next if /^;/;
        next if /^ *$/;

        if (/^\*/) {
                chop;
                $Name = substr($_, 1);
                $Name =~ s/^ +//;
                $Name =~ s/ +$//;
                $Count = 0;
                next;
        }

        next unless $Started;

        chop;
        $Original = $_;
        $Count++;
        
        s/^ +//; /^"[^"]*"|[^ ]+/;
        $Switches = $&; $_ = $';
        $Switches = "" if $Switches eq "-";
	s/^ +//; /^"[^"]*"|[^ ]+/;
        $Pattern = $&; $_ = $';
        s/^ +//; /^"[^"]*"|[^ ]+/;
        $Marker = $&; $_ = $';
        s/^ +//;
	$Line = $_;

        $UnmarkedLine = $Line;
        $UnmarkedLine =~ s/$Marker//g if $Marker !~ /[a-z]/;

        $Total++;
        open(RESULT, "echo $UnmarkedLine| $TestProg $Switches -M$Marker $Pattern|");
        $Result = <RESULT>;
        chop($Result);
        $Okay = 0;
        if ($Marker =~ /[a-z]/) {
                # Shouldn't match, check that failure is as expected
                if ($Fail{$Marker} eq "") {
                        #Should not get any result
                        $Okay = 1 if $Result eq "";
                        print "#Failed  OK: $Original\n";
                        &Ok($Total);
                } elsif (index($Result, $Fail{$Marker}) != ($[ - 1)) {
                        $Okay = 1;
                        print "#Failed  OK: $Original\n";
                        &Ok($Total);
                }

        } else {
                #Should match, with markers re-inserted as per test
                if ($Result eq $Line) {
                        $Okay = 1;
                        print "#Matched OK: $Original\n";
                        &Ok($Total);
                }
        }

        #Did the test perform satisfactorily?
        if (! $Okay) {
                #Matched wrongly or didn't fail when it should have
                print "#Error: >$Original<\n";
                print "#  got: >$Result<\n";
                $Errors++;
                &NotOk($Total);
        }

} #DoTest

sub DoTestFinalise {

        print "#Total: $Total\n";

} #DoTestFinalise

1;
