/************************************************************************/
/*                                                                      */
/*      ACodec -- Assembly version of table-driven decoder              */
/*                                                                      */
/************************************************************************/

#ifndef ACODEC_H
#define ACODEC_H

#include <ccodec.h>
#include <compdef.h>
#include <hufftree.h>

#ifdef __cplusplus
extern "C" {
#endif /*__cplusplus*/

/************************************************************************/
/*                                                                      */
/*      Init -- Prepare module for operation                            */
/*                                                                      */
/************************************************************************/
void
ACodec_Init(void);

/************************************************************************/
/*                                                                      */
/*      Decode -- Decode compressed stream using table-driven FSA       */
/*                                                                      */
/************************************************************************/
UINT PAGE_ALIGNED
ACodec_Decode(CCODEC_TABLE pTab,
              BYTE *pInput, UINT *pNrDecodeBytes, BYTE *pOutput);

#ifdef __cplusplus
}
#endif /*__cplusplus*/

#endif /*ACODEC_H*/
