/************************************************************************/
/*                                                                      */
/*      Decode -- Decode compressed stream using table-driven FSA       */
/*                                                                      */
/************************************************************************/
UINT
CCodec_Decode(CCODEC_TABLE pTab, BYTE *pInput,
              UINT *pNrDecodeBytes, BYTE *pOutput)
{
        BYTE *pInStart = pInput;
        BYTE *pOutStart = pOutput;
        WORD Reg = BYTES2WORD(pInput[0], pInput[1]);
        UINT Act = STOP;
        BYTE *pStateTable = &pTab->Table[0][0];
        BYTE LastAlign;
        BYTE Next8;
        UINT NrBytes = 32767;

        pInput += 2;
        Next8 = HIBYTE(Reg);
        Act = pStateTable[Next8];
BitAlign7:
        if (NrBytes-- == 0) goto LastAct;
        switch (Act) {
        case USE1:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 7);
                Act = pStateTable[Next8];
                goto BitAlign6; /*break;*/

        case USE2:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 6);
                Act = pStateTable[Next8];
                goto BitAlign5; /*break;*/

        case USE3:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 5);
                Act = pStateTable[Next8];
                goto BitAlign4; /*break;*/

        case USE4:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 4);
                Act = pStateTable[Next8];
                goto BitAlign3; /*break;*/

        case USE5:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 3);
                Act = pStateTable[Next8];
                goto BitAlign2; /*break;*/

        case USE6:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 2);
                Act = pStateTable[Next8];
                goto BitAlign1; /*break;*/

        case USE7:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 1);
                Act = pStateTable[Next8];
                goto BitAlign0; /*break;*/

        case USE8:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg);
                Reg = (Reg << 8) | *pInput++;
                Act = pStateTable[Next8];
                goto BitAlign7; /*break;*/

        case USEGT8:
                NrBytes++;
                pStateTable = &pTab->Table[pStateTable[Next8 + NRBYTES]][0];
                Next8 = LOBYTE(Reg);
                Reg = (Reg << 8) | *pInput++;
                Act = pStateTable[Next8];
                goto BitAlign7; /*break;*/

        case STOP:
                LastAlign = 7;
                goto LastAct;

        default:
                printf("?? Unknown action: %02x\n", Act);
                exit(62);

        }

BitAlign6:
        if (NrBytes-- == 0) goto LastAct;
        switch (Act) {
        case USE1:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 6);
                Act = pStateTable[Next8];
                goto BitAlign5; /*break;*/

        case USE2:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 5);
                Act = pStateTable[Next8];
                goto BitAlign4; /*break;*/

        case USE3:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 4);
                Act = pStateTable[Next8];
                goto BitAlign3; /*break;*/

        case USE4:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 3);
                Act = pStateTable[Next8];
                goto BitAlign2; /*break;*/

        case USE5:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 2);
                Act = pStateTable[Next8];
                goto BitAlign1; /*break;*/

        case USE6:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 1);
                Act = pStateTable[Next8];
                goto BitAlign0; /*break;*/

        case USE7:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg);
                Reg = (Reg << 8) | *pInput++;
                Act = pStateTable[Next8];
                goto BitAlign7; /*break;*/

        case USE8:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 7);
                Act = pStateTable[Next8];
                goto BitAlign6; /*break;*/

        case USEGT8:
                NrBytes++;
                pStateTable = &pTab->Table[pStateTable[Next8 + NRBYTES]][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 7);
                Act = pStateTable[Next8];
                goto BitAlign6; /*break;*/

        case STOP:
                LastAlign = 6;
                goto LastAct;

        default:
                printf("?? Unknown action: %02x\n", Act);
                exit(62);

        }

BitAlign5:
        if (NrBytes-- == 0) goto LastAct;
        switch (Act) {
        case USE1:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 5);
                Act = pStateTable[Next8];
                goto BitAlign4; /*break;*/

        case USE2:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 4);
                Act = pStateTable[Next8];
                goto BitAlign3; /*break;*/

        case USE3:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 3);
                Act = pStateTable[Next8];
                goto BitAlign2; /*break;*/

        case USE4:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 2);
                Act = pStateTable[Next8];
                goto BitAlign1; /*break;*/

        case USE5:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 1);
                Act = pStateTable[Next8];
                goto BitAlign0; /*break;*/

        case USE6:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg);
                Reg = (Reg << 8) | *pInput++;
                Act = pStateTable[Next8];
                goto BitAlign7; /*break;*/

        case USE7:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 7);
                Act = pStateTable[Next8];
                goto BitAlign6; /*break;*/

        case USE8:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 6);
                Act = pStateTable[Next8];
                goto BitAlign5; /*break;*/

        case USEGT8:
                NrBytes++;
                pStateTable = &pTab->Table[pStateTable[Next8 + NRBYTES]][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 6);
                Act = pStateTable[Next8];
                goto BitAlign5; /*break;*/

        case STOP:
                LastAlign = 5;
                goto LastAct;

        default:
                printf("?? Unknown action: %02x\n", Act);
                exit(62);

        }

BitAlign4:
        if (NrBytes-- == 0) goto LastAct;
        switch (Act) {
        case USE1:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 4);
                Act = pStateTable[Next8];
                goto BitAlign3; /*break;*/

        case USE2:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 3);
                Act = pStateTable[Next8];
                goto BitAlign2; /*break;*/

        case USE3:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 2);
                Act = pStateTable[Next8];
                goto BitAlign1; /*break;*/

        case USE4:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 1);
                Act = pStateTable[Next8];
                goto BitAlign0; /*break;*/

        case USE5:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg);
                Reg = (Reg << 8) | *pInput++;
                Act = pStateTable[Next8];
                goto BitAlign7; /*break;*/

        case USE6:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 7);
                Act = pStateTable[Next8];
                goto BitAlign6; /*break;*/

        case USE7:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 6);
                Act = pStateTable[Next8];
                goto BitAlign5; /*break;*/

        case USE8:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 5);
                Act = pStateTable[Next8];
                goto BitAlign4; /*break;*/

        case USEGT8:
                NrBytes++;
                pStateTable = &pTab->Table[pStateTable[Next8 + NRBYTES]][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 5);
                Act = pStateTable[Next8];
                goto BitAlign4; /*break;*/

        case STOP:
                LastAlign = 4;
                goto LastAct;

        default:
                printf("?? Unknown action: %02x\n", Act);
                exit(62);

        }

BitAlign3:
        if (NrBytes-- == 0) goto LastAct;
        switch (Act) {
        case USE1:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 3);
                Act = pStateTable[Next8];
                goto BitAlign2; /*break;*/

        case USE2:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 2);
                Act = pStateTable[Next8];
                goto BitAlign1; /*break;*/

        case USE3:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 1);
                Act = pStateTable[Next8];
                goto BitAlign0; /*break;*/

        case USE4:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg);
                Reg = (Reg << 8) | *pInput++;
                Act = pStateTable[Next8];
                goto BitAlign7; /*break;*/

        case USE5:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 7);
                Act = pStateTable[Next8];
                goto BitAlign6; /*break;*/

        case USE6:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 6);
                Act = pStateTable[Next8];
                goto BitAlign5; /*break;*/

        case USE7:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 5);
                Act = pStateTable[Next8];
                goto BitAlign4; /*break;*/

        case USE8:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 4);
                Act = pStateTable[Next8];
                goto BitAlign3; /*break;*/

        case USEGT8:
                NrBytes++;
                pStateTable = &pTab->Table[pStateTable[Next8 + NRBYTES]][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 4);
                Act = pStateTable[Next8];
                goto BitAlign3; /*break;*/

        case STOP:
                LastAlign = 3;
                goto LastAct;

        default:
                printf("?? Unknown action: %02x\n", Act);
                exit(62);

        }

BitAlign2:
        if (NrBytes-- == 0) goto LastAct;
        switch (Act) {
        case USE1:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 2);
                Act = pStateTable[Next8];
                goto BitAlign1; /*break;*/

        case USE2:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 1);
                Act = pStateTable[Next8];
                goto BitAlign0; /*break;*/

        case USE3:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg);
                Reg = (Reg << 8) | *pInput++;
                Act = pStateTable[Next8];
                goto BitAlign7; /*break;*/

        case USE4:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 7);
                Act = pStateTable[Next8];
                goto BitAlign6; /*break;*/

        case USE5:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 6);
                Act = pStateTable[Next8];
                goto BitAlign5; /*break;*/

        case USE6:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 5);
                Act = pStateTable[Next8];
                goto BitAlign4; /*break;*/

        case USE7:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 4);
                Act = pStateTable[Next8];
                goto BitAlign3; /*break;*/

        case USE8:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 3);
                Act = pStateTable[Next8];
                goto BitAlign2; /*break;*/

        case USEGT8:
                NrBytes++;
                pStateTable = &pTab->Table[pStateTable[Next8 + NRBYTES]][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 3);
                Act = pStateTable[Next8];
                goto BitAlign2; /*break;*/

        case STOP:
                LastAlign = 2;
                goto LastAct;

        default:
                printf("?? Unknown action: %02x\n", Act);
                exit(62);

        }

BitAlign1:
        if (NrBytes-- == 0) goto LastAct;
        switch (Act) {
        case USE1:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg >> 1);
                Act = pStateTable[Next8];
                goto BitAlign0; /*break;*/

        case USE2:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg);
                Reg = (Reg << 8) | *pInput++;
                Act = pStateTable[Next8];
                goto BitAlign7; /*break;*/

        case USE3:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 7);
                Act = pStateTable[Next8];
                goto BitAlign6; /*break;*/

        case USE4:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 6);
                Act = pStateTable[Next8];
                goto BitAlign5; /*break;*/

        case USE5:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 5);
                Act = pStateTable[Next8];
                goto BitAlign4; /*break;*/

        case USE6:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 4);
                Act = pStateTable[Next8];
                goto BitAlign3; /*break;*/

        case USE7:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 3);
                Act = pStateTable[Next8];
                goto BitAlign2; /*break;*/

        case USE8:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 2);
                Act = pStateTable[Next8];
                goto BitAlign1; /*break;*/

        case USEGT8:
                NrBytes++;
                pStateTable = &pTab->Table[pStateTable[Next8 + NRBYTES]][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 2);
                Act = pStateTable[Next8];
                goto BitAlign1; /*break;*/

        case STOP:
                LastAlign = 1;
                goto LastAct;

        default:
                printf("?? Unknown action: %02x\n", Act);
                exit(62);

        }

BitAlign0:
        if (NrBytes-- == 0) goto LastAct;
        switch (Act) {
        case USE1:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Next8 = LOBYTE(Reg);
                Reg = (Reg << 8) | *pInput++;
                Act = pStateTable[Next8];
                goto BitAlign7; /*break;*/

        case USE2:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 7);
                Act = pStateTable[Next8];
                goto BitAlign6; /*break;*/

        case USE3:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 6);
                Act = pStateTable[Next8];
                goto BitAlign5; /*break;*/

        case USE4:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 5);
                Act = pStateTable[Next8];
                goto BitAlign4; /*break;*/

        case USE5:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 4);
                Act = pStateTable[Next8];
                goto BitAlign3; /*break;*/

        case USE6:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 3);
                Act = pStateTable[Next8];
                goto BitAlign2; /*break;*/

        case USE7:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 2);
                Act = pStateTable[Next8];
                goto BitAlign1; /*break;*/

        case USE8:
                *pOutput++ = pStateTable[Next8 + NRBYTES];
                pStateTable = &pTab->Table[0][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 1);
                Act = pStateTable[Next8];
                goto BitAlign0; /*break;*/

        case USEGT8:
                NrBytes++;
                pStateTable = &pTab->Table[pStateTable[Next8 + NRBYTES]][0];
                Reg = (Reg << 8) | *pInput++;
                Next8 = LOBYTE(Reg >> 1);
                Act = pStateTable[Next8];
                goto BitAlign0; /*break;*/

        case STOP:
                LastAlign = 0;
                goto LastAct;

        default:
                printf("?? Unknown action: %02x\n", Act);
                exit(62);

        }


LastAct:
        /*Did decoding the stop symbol stay within the current byte?*/
        if (LastAlign >= pStateTable[Next8 + NRBYTES]) {
                /*Yes, don't consume next byte*/
                pInput--;
        }


        *pNrDecodeBytes = pOutput - pOutStart;
        return pInput - pInStart + 1;

} /*Decode*/
