/************************************************************************/
/*                                                                      */
/*      FileFreq -- Collate charater frequency stats for file           */
/*                                                                      */
/*      Copyright (C) Grouse Software 1997.  All rights reserved.       */
/*      Written for Grouse by behoffski (Brenton Hoff).                 */
/*                                                                      */
/*      Free software: no warranty; use anywhere is ok; spread the      */
/*      sources; note any mods; share variations and derivatives        */
/*      (including sending to behoffski@grouse.com.au).                 */
/*                                                                      */
/************************************************************************/

#ifndef FILEFREQ_H
#define FILEFREQ_H

#include <compdef.h>

#ifdef __cplusplus
extern "C" {
#endif /*__cplusplus*/

/************************************************************************/
/*                                                                      */
/*      Init -- Prepare module for operation                            */
/*                                                                      */
/************************************************************************/
void
FileFreq_Init(void);

/************************************************************************/
/*                                                                      */
/*      Analyse -- Accumulate frequency stats for specified file        */
/*                                                                      */
/*      This function reads the file data, and increments the           */
/*      frequency counters for each byte found.  The frequencies        */
/*      are not initialised before counting, so that the                */
/*      analysis can span multiple files.  The client must              */
/*      initialise all members of the frequency count array to 0        */
/*      before the first invocation of this routine.                    */
/*                                                                      */
/************************************************************************/
BOOL
FileFreq_Analyse(char *pFilename, UINT32 *pFreqs);

#ifdef __cplusplus
}
#endif /*__cplusplus*/

#endif /*FILEFREQ_H*/
