NAME
        ghuff -- Demonstrate the Grouse Huffman decoder


SYNOPSIS
        ghuff <s> e  <src> <squish>   -- Encode <src> to <squish>
        ghuff <s> d  <squish> <dest>  -- Decode <squish> to <dest> (asm)
        ghuff <s> D  <squish> <dest>  -- Decode <squish> to <dest> (C)
        ghuff <s> dt <squish>         -- Time asm decode
        ghuff <s> Dt <squish>         -- Time C decode

        <s> is a security word.  Run ghuff without any parameters
        to find out more about this.


DESCRIPTION
        This program demonstrates a high-speed Huffman decoder
        implemented using the Grouse finite-state machine
        architecture.  It can encode a file into a Huffman-coded
        version and then decode the file again.  The compression
        ratios are truly pathetic, but that's not the point.

        The main feature is that the decoder can usually
        decompress text and ZIP files at a cost of just 14 cycles
        per output byte on a Pentium.  This figure doesn't
        include the cost of file input and output activity; your
        mileage may vary.  The performance on any other machine
        type (including Pentium Pro and Pentium II) is unknown.

        Warning: The program has NOT been exhaustively tested.
        Use at your own risk.


OPTIONS
        The timing functions focus on the decoder's performance,
        but ignores file output overhead and tries to minimise
        file input overhead.  It performs the decode 100 times,
        so that the performance of the decoder may be measured.


COPYRIGHT
        ghuff is Copyright (C) 1997 by Grouse Software.  All
        rights reserved.  The Grouse finite-state architecture
        and the Huffman decoder implementation were invented by
        behoffski (Brenton Hoff).

        This manual page was derived from the GNU wc man page.


LICENCING
        ghuff is freeware/mailware/postcardware.  If you find
        ghuff or the Grouse finite-state machine concept valuable,
        please let behoffski know by sending a postcard or an
        e-mail cheerio.

        If you improve the ghuff sources, please consider sharing
        your improvements, including e-mail to behoffski.
        If you really like Grouse's ideas and style, consider
        donating $20 to fund time to create more public-domain
        software.  If ghuff or the Grouse FSA are used in your
        application, please include an acknowledgement in the
        documentation.


                Grouse Software Pty Ltd
                PO Box 195
                Willaston, South Australia, 5118
                Australia

                http://www.grouse.com.au/
                ftp://ftp.grouse.com.au/clients/grouse
                e-mail:info@grouse.com.au
