NAME
        wc - print the number of bytes, words, and lines in files


SYNOPSIS
        wc [-cwldV] [file...]


DESCRIPTION
        wc counts the number of bytes, whitespace-separated words,
        and newlines in each given file, or the standard input  if
        none  are  given  or  when  a file named `-' is given.  It
        prints one line of counts for each file, and if  the  file
        was given as an argument, it prints the filename following
        the counts.  If more than one filename is given, wc prints
        a  final  line  containing the cumulative counts, with the
        filename `total'.  The counts are printed  in  the  order:
        lines, words, bytes.

        By default, wc prints all three counts.  Options can spec-
        ify that only certain counts be printed.  Options  do  not
        undo others  previously given,  so wc -cw  prints both the
        byte counts and the word counts.


OPTIONS
        -c     Print only the byte counts.

        -w     Print only the word counts.

        -l     Print only the newline counts.

        -d     Recurse through subdirectories.

        -V     Print version on stdout and then exit.


COPYRIGHT
        wc is Copyright (C) 1995-1997 by Grouse Software.  All
        rights reserved.  The Grouse finite-state architecture
        and the wc implementation were created by behoffski
        (Brenton Hoff).

        This manual page was derived from the GNU wc man page.

LICENCING
        wc is freeware/mailware/postcardware.  If you find
        wc or the Grouse finite-state machine concept valuable,
        please let behoffski know by sending a postcard or an
        e-mail cheerio.

        If you improve the wc sources, please consider sharing
        your improvements, including e-mail to behoffski.
        If you really like Grouse's ideas and style, consider
        donating $20 to fund time to create more public-domain
        software.  If wc or the Grouse FSA are used in your
        application, please include an acknowledgement in the
        documentation.


                Grouse Software Pty Ltd
                PO Box 195
                Willaston, South Australia, 5118
                Australia

                http://www.grouse.com.au/
                ftp://ftp.grouse.com.au/clients/grouse
                e-mail:info@grouse.com.au
